<template>
  <div v-if="isVisible">
    <v-card
      :loading="isLoadingCumplimientoCalificacionDisciplinaPuntosContacto"
    >
      <IdGrafico id="015" />
      <div></div>
      <div class="title-card-component">
        Cumplimiento de la disciplina por los negocios que componen
        <span
          v-if="globalFilters && globalFilters.filters.descripcion_ceco"
          class="bold keep-spaces"
          >{{ " " + globalFilters.filters.id_ceco }} -
          {{ globalFilters.filters.descripcion_ceco }}</span
        >
      </div>
      <div class="cardBoby">
        <div class="grafica">
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCumplimientoCalificacionDisciplinaPuntosContacto"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            v-show="isLoadingCumplimientoCalificacionDisciplinaPuntosContacto"
          ></v-skeleton-loader>
          <v-skeleton-loader
            type="list-item-avatar"
            tile
            class="mx-auto"
            :loading="isLoadingCumplimientoCalificacionDisciplinaPuntosContacto"
          >
            <span class="bold">Cecos</span>
            <template
              v-for="(itemCecoDisciplina,
              indexItemCecoDisciplina) in cecosDisciplina"
            >
              <div :key="indexItemCecoDisciplina" class="negocio">
                <div :style="{ width: widthCecoColumn + 'px' }">
                  <a @click="zoomSearchCeco(itemCecoDisciplina)" class="liga">{{
                    itemCecoDisciplina.descripcion
                  }}</a>
                </div>
                <div class="medidor">
                  <div
                    class="porcentaje text-center"
                    v-bind:style="{
                      width: itemCecoDisciplina.width + '%',
                      backgroundColor: itemCecoDisciplina.rango.detalle
                    }"
                  >
                    {{ itemCecoDisciplina.calificacion }}%
                  </div>
                </div>
              </div>
            </template>
          </v-skeleton-loader>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
a.liga {
  color: #000000 !important;
  text-decoration: underline;
  font-family: "AvenirNextLTPro-Medium";
  cursor: pointer;
}
.keep-spaces {
  white-space: pre-wrap;
}
.title-card-component {
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: #1e2945;
  color: white;
  padding: 5px 0px;
}
</style>
<style scoped>
.contenedorCards {
  display: flex;
}
.card {
  margin: 10px;
  min-height: 183px;
  -webkit-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  -moz-box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
  box-shadow: 3px 3px 7px 0px rgba(204, 204, 204, 1);
}
.cardHeader {
  height: 40px;
  background-color: #f7f7f7;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding: 20px;
  font-family: "AvenirNextLTPro-Medium";
}
.cardHeader > .porcentaje {
  display: flex;
  justify-content: center;
  align-items: center;
}
.flechas {
  width: 20px;
  margin-left: 10px;
  cursor: pointer;
}
.cardBoby {
  padding: 10px 0px;
}
.grafica {
  padding-top: 5px;
}
.grafica img {
  width: 100%;
}
.negocio {
  display: flex;
  border-top: solid 1px #f7f7f7;
  border-bottom: solid 1px #f7f7f7;
  margin: 5px 0px;
}
.negocio > .imga {
  width: 61px;
  display: flex;
  align-items: center;
  margin-right: 10px;
  padding-left: 10px;
  justify-content: center;
  height: 20px;
}
.negocio > .medidor {
  width: 81%;
  height: 25px;
}
.negocio > .medidor > .porcentaje {
  height: 25px;
  background-color: grey;
  position: relative;
  border-top-right-radius: 21px;
  border-bottom-right-radius: 21px;
  display: flex;
  align-items: center;
  padding-left: 10px;
  color: white;
  justify-content: center;
}
</style>
<script>
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
export default {
  name: "Component-CumplimientoCalificacionDisciplinaPuntosContactoNegocio",
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  components: {
    IdGrafico
  },
  data() {
    return {
      isLoadingCumplimientoCalificacionDisciplinaPuntosContacto: true,
      isPersentValue: true,
      methodsSemaforo: null,
      globalFilters: null,
      originalFilters: null,
      cecosDisciplina: [],
      widthCecoColumn: 120,
      isVisible: true,
      zoomSearchCeco: null
    };
  },
  methods: {
    listenSearchConsulta(globalFilters, originalFilters, zoomSearchCeco) {
      if (
        globalFilters.final_filters.nivel_geografico == 1 &&
        globalFilters.final_filters.id_negocio > 0 &&
        globalFilters.final_filters.id_disciplina == 5
      ) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.originalFilters = originalFilters;
        this.zoomSearchCeco = zoomSearchCeco;
        this.getCumplimientoCalificacionDisciplinaPuntosContacto();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getCumplimientoCalificacionDisciplinaPuntosContacto() {
      this.isLoadingCumplimientoCalificacionDisciplinaPuntosContacto = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/calificacion/disciplina/negocio/punto/contacto",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoCalificacionDisciplinaPuntosContacto(data);
              }
            } else {
              self.setCumplimientoCalificacionDisciplinaPuntosContacto([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoCalificacionDisciplinaPuntosContacto = false;
        });
    },
    setCumplimientoCalificacionDisciplinaPuntosContacto(cecosDisciplina) {
      const self = this;
      cecosDisciplina.forEach((itemCeco) => {
        itemCeco.descripcion = itemCeco.id_ceco + " - " + itemCeco.descripcion;
        itemCeco.width = itemCeco.calificacion;
        if (
          self.methodsSemaforo &&
          self.methodsSemaforo.getRangoByLimit(itemCeco.calificacion)
        ) {
          let rango = self.methodsSemaforo.getRangoByLimit(itemCeco.calificacion);
          itemCeco.rango = {
            detalle: rango.detalle
          };
        } else {
          itemCeco.rango = {
            detalle: ""
          };
        }
      });
      if (cecosDisciplina && cecosDisciplina.length > 0) {
        let cecoLargeName = cecosDisciplina.reduce((prev, current) => {
          let descripcionPrev = 0;
          if (prev && prev.descripcion) {
            descripcionPrev = prev.descripcion.length;
          }
          const descripcionCurrent = current.descripcion.length;
          return descripcionPrev > descripcionCurrent ? prev : current;
        });
        if (typeof cecoLargeName === "object") {
          cecoLargeName = cecoLargeName.descripcion.length;
        }
        this.widthCecoColumn = cecoLargeName * 10;
      }
      this.cecosDisciplina = cecosDisciplina;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters) {
      this.getCumplimientoCalificacionDisciplinaPuntosContacto();
    }
  }
};
</script>
